<template>
  <div class="flex flex-middle flex-center deposit_slider">
    <Btn
      class="deposit_slider-left deposit_slider-btn"
      @touchstart="touchstart(-step)"
      @touchend="touchend(-step)"
      @click="changeAmount(-step)"><i class="i-icon-minus"></i></Btn>
    <div class="flex flex-center deposit_slider-body myBets_body-slider">
      <div class="flex flex-middle">
        <div class="progress"></div>
      </div>
      <BSlider
        :showValues="false"
        :zeroBlock="min"
        :min="min"
        :max="max"
        :step="step"
        v-model="amount"></BSlider>
    </div>
    <Btn
      class="deposit_slider-right deposit_slider-btn"
      @touchstart="touchstart(step)"
      @touchend="touchend(step)"
      @click="changeAmount(step)"><i class="i-icon-plus"></i></Btn>
  </div>
</template>

<script>
  import BSlider from '~/components/UI/Slider';
  import Btn from '~/components/UI/BtnSign';

  export default {
    name: "Slider",
    props: {
      min: {
        type: Number,
        default: 1
      },
      max: {
        type: Number,
        default: 100
      },
      step: {
        type: Number,
        default: 1
      },
      val: {
        type: Number,
        default: 5
      }
    },
    data() {
      return {
        interval: null,
        amount: 0
      }
    },
    components: {
      BSlider,
      Btn
    },
    computed: {},
    methods: {
      changeAmount(val) {
        this.amount += val;
      },
      touchstart(val) {
        this.interval = setInterval(_ => {
          clearInterval(this.interval);
          this.interval = setInterval(_ => {
            this.changeAmount(val);
          }, 100);
        }, 600);
      },
      touchend() {
        clearInterval(this.interval);
      }
    },
    watch: {
      'amount': function () {
        this.$emit('change', this.amount);
      },
      val() {
        this.amount = this.val;
      }
    }
  }
</script>
